<?php
// $Id:
/**
 * @file
 * Provide views data for tycoon.module
 */


/**
 * Implementation of hook_views_data()
 */
function tycoon_views_data() {
  /* 
   * TABLE tycoon_transaction
   */ 
  $data['tycoon_transaction']['table']['group']  = t('Tycoon Transaction');
  $data['tycoon_transaction']['table']['base'] = array(
    'field' => 'txid',
    'title' => t('Tycoon Transactions'),
    'help' => t("Tycoon transactions collected through Tycoon API."),
  );
  
  $data['tycoon_transaction_node']['table']['join'] = array(
    'users' => array(
      'left_field' => 'uid',
      'field' => 'uid',
    ),   
  );

  $data['tycoon_transaction']['txid'] = array(
    'title' => t('Transaction ID'),
    'help' => t('The ID of the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'relationship' => array(
      'base' => 'tycoon_transaction_node',
      'handler' => 'views_handler_relationship',
      'label' => t('Transaction ID'),
    ),
  );
  
  $data['tycoon_transaction']['state'] = array(
    'title' => t('State'),
    'help' => t('The current state of the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    
  );
  
  $data['tycoon_transaction']['total'] = array(
    'title' => t('Total'),
    'help' => t('The total of the Tycoon'),
    'field' => array(
      'handler' => 'views_handler_field_money',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  ); 

  $data['tycoon_transaction']['total_paid'] = array(
    'title' => t('Total Paid'),
    'help' => t('The total paid for the Tycoon'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );   

  $data['tycoon_transaction']['currency'] = array(
    'title' => t('Currency'),
    'help' => t('The currency of the Tycoon'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );     
  
  $data['tycoon_transaction']['uid'] = array(
    'title' => t('User ID'),
    'help' => t('The UID of the transaction'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'users',
      'field' => 'uid',
      'base field' => 'uid',
      'label' => t('user'),
    ),    
  );     
  
  $data['tycoon_transaction']['mail'] = array(
    'title' => t('Email'),
    'help' => t('The user\'s email for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_transaction']['first_name'] = array(
    'title' => t('First Name'),
    'help' => t('The user\'s first name of the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['tycoon_transaction']['last_name'] = array(
    'title' => t('Last Name'),
    'help' => t('The user\'s last name of the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_transaction']['phone'] = array(
    'title' => t('Phone'),
    'help' => t('The user\'s phone number for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
      
  $data['tycoon_transaction']['company'] = array(
    'title' => t('Company'),
    'help' => t('The user\'s company for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_transaction']['street1'] = array(
    'title' => t('Street Address 1'),
    'help' => t('The user\'s street address for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_transaction']['street2'] = array(
    'title' => t('Street Address 2'),
    'help' => t('The user\'s second line street address for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['tycoon_transaction']['city'] = array(
    'title' => t('City'),
    'help' => t('The user\'s city for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_transaction']['province'] = array(
    'title' => t('First Name'),
    'help' => t('The user\'s province for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_transaction']['postal_code'] = array(
    'title' => t('Postal Code'),
    'help' => t('The user\'s postal code for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
      
  $data['tycoon_transaction']['country'] = array(
    'title' => t('Country'),
    'help' => t('The user\'s country for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['tycoon_transaction']['created'] = array(
    'title' => t('Created Date'),
    'help' => t('The creation date of the Tycoon'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );     
  
  $data['tycoon_transaction']['updated'] = array(
    'title' => t('Updated Date'),
    'help' => t('The updated date of the Tycoon'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );     

  $data['tycoon_transaction']['data'] = array(
    'title' => t('Data'),
    'help' => t('The data of the Tycoon'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  ); 

  /* 
   * TABLE tycoon_transaction_node
   */
  $data['tycoon_transaction_node']['table']['group']  = t('Tycoon Transaction Node');

  $data['tycoon_transaction_node']['table']['join'] = array(
    'tycoon_transaction' => array(
      'left_field' => 'txid',
      'field' => 'txid',
    ),
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),    
  );

  $data['tycoon_transaction_node']['txid'] = array(
    'title' => t('Transaction ID'),
    'help' => t('The transaction ID for the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'relationship' => array(
      'base' => 'tycoon_transaction',
      'handler' => 'views_handler_relationship',
      'label' => t('Transaction ID'),
      'base field' => 'txid',
      'field' => 'txid',
    ),
  );
  
  $data['tycoon_transaction_node']['nid'] = array(
    'title' => t('Node ID'),
    'help' => t('The Node ID for the transaction.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'relationship' => array(
      'base' => 'node',
      'handler' => 'views_handler_relationship',
      'label' => t('Node ID'),
      'base field' => 'nid',
      'field' => 'nid',
    ),
  );  
  
  /* 
   * TABLE tycoon_line_item
   */
  $data['tycoon_line_item']['table']['group']  = t('Tycoon Line Item');

  $data['tycoon_line_item']['table']['join'] = array(
    'tycoon_transaction' => array(
      'left_field' => 'txid',
      'field' => 'txid',
    ),
  );
  
  $data['tycoon_line_item']['txid'] = array(
    'title' => t('Transaction ID'),
    'help' => t('The transaction ID for the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'relationship' => array(
      'base' => 'tycoon_transaction',
      'handler' => 'views_handler_relationship',
      'label' => t('Transaction ID'),
      'base field' => 'txid',
      'field' => 'txid',
    ),
  );
  
  $data['tycoon_line_item']['identifier'] = array(
    'title' => t('Identifier'),
    'help' => t('The identifier for the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),    
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_line_item']['title'] = array(
    'title' => t('Title'),
    'help' => t('The title of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_line_item']['description'] = array(
    'title' => t('Description'),
    'help' => t('The description of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  $data['tycoon_line_item']['qty'] = array(
    'title' => t('Quantity'),
    'help' => t('The quantity of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  
  $data['tycoon_line_item']['price'] = array(
    'title' => t('Price'),
    'help' => t('The price of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_float',
      'parent' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );  
  
  $data['tycoon_line_item']['taxable'] = array(
    'title' => t('Taxable'),
    'help' => t('The taxability of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );  

  $data['tycoon_line_item']['weight'] = array(
    'title' => t('Weight'),
    'help' => t('The weight of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );  
  
  $data['tycoon_line_item']['data'] = array(
    'title' => t('Data'),
    'help' => t('The data of the line item.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
      'allow empty' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),       
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );  

  return $data;
}

/**
 * Implements hook_views_handlers().
 */
function tycoon_views_handlers() { 
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'tycoon') . '/views/handlers',
    ),
    'handlers' => array(
      // field handlers
      'views_handler_field_money' => array(
        'parent' => 'views_handler_field',
      ),
    ),
  );
}